/*
 * Modification History
 *
 * 2002-August-1  Jason Rohrer
 * Created.
 */



#include "minorGems/util/StringBufferOutputStream.h"



StringBufferOutputStream::StringBufferOutputStream()
    : mCharacterVector( new SimpleVector<char>() ) {

    }



StringBufferOutputStream::~StringBufferOutputStream() {

    delete mCharacterVector;
    }



char *StringBufferOutputStream::getString() {

    int numChars = mCharacterVector->size();

    char *returnArray = new char[ numChars + 1 ];

    for( int i=0; i<numChars; i++ ) {
        returnArray[i] = *( mCharacterVector->getElement( i ) );
        }
    returnArray[ numChars ] = '\0';

    return returnArray;
    }



long StringBufferOutputStream::write( unsigned char *inBuffer,
                                      long inNumBytes ) {

    for( int i=0; i<inNumBytes; i++ ) {
        mCharacterVector->push_back( (char)( inBuffer[ i ] ) );
        }
    
    return inNumBytes;
    }

